properties(
	[
pipelineTriggers([parameterizedCron('''TZ=Asia/Kolkata 
        00 00 * * 2 %executionEnv=Prod US;suite=Delete;module=Delete;
		00 00 * * 2 %executionEnv=Prod IN;suite=Delete;module=Delete
		00 00 * * 2 %executionEnv=Prod KSA;suite=Delete;module=Delete
		00 00 * * 5 %executionEnv=Staging;suite=Delete;module=Delete
        ''')]),
	parameters([
		[
			$class: 'ChoiceParameter', 
			choiceType: 'PT_RADIO', 
			filterLength: 1, 
			filterable: false, 
			name: 'suite', 
			randomName: 'choice-parameter-453857694696436', 
			script: [
				$class: 'GroovyScript', 
				fallbackScript: [classpath: [], sandbox: false, script: ''], 
				script: [
					classpath: [], 
					sandbox: false, 
					script: '''return[
					\'Regression:selected\',
					\'Delete\'
					]'''
				]
			]
		], 
		string(defaultValue: 'id', name: 'SlackThreadId'),
		[
			$class: 'CascadeChoiceParameter', 
			choiceType: 'PT_CHECKBOX', 
			filterLength: 1, 
			filterable: false, 
			name: 'module', 
			randomName: 'choice-parameter-454966654763424', 
			referencedParameters: 'suite', 
			script: [
				$class: 'GroovyScript', 
				fallbackScript: [classpath: [], sandbox: false, script: ''], 
				script: [
				classpath: [], 
					sandbox: false, 
					script: '''if(suite.equals("Regression")){
					return ['Segments:selected','Integration:selected','Campaigns:selected']
					}else{
					return ['Caution! You are about to delete data:disabled','Delete Journeys','Delete Relays','Delete WA Campaigns','Delete SMS Campaigns','Delete Email Campaigns','Delete WebPush Campaigns','Delete InLine Content','Delete Push Campaigns','Delete InApp Content','Delete Viber Campaigns','Delete OnSite Notif','Delete Segments','Delete Static Lists','Delete SSP','Delete ESP','Delete WSP','Delete InLineApp Content','Delete WSP Templates','Delete InLineApp CustomTemplates','Delete Catalogs','Delete Recommendations','Delete Dashboards','Delete Custom Alerts','Delete Funnels']
					}'''	
				]
			]
		],
		[
		$class: 'ChoiceParameter', 
		choiceType: 'PT_RADIO', 
		filterLength: 1, 
		filterable: false, 
		name: 'executionEnv', 
		randomName: 'choice-parameter-457227329686590', 
		script: [
			$class: 'GroovyScript', 
			fallbackScript: [classpath: [], sandbox: false, script: ''], 
			script: [
				classpath: [], 
				sandbox: false, 
				script: '''return[
				\'Prod US\',
				\'Prod IN\',
				\'Prod KSA\',
				\'Prod Beta\',
				\'Staging Dev\',
				\'Staging:selected\'
				]'''
			]
		]
	]
	])
])
namespacePrompt='default'
def accountName=getAccountName(params.executionEnv)
colorValue="color"
slackExecutionMessage="message"
boolean scheduledTrigger=!currentBuild.getBuildCauses('org.jenkinsci.plugins.parameterizedscheduler.ParameterizedTimerTriggerCause').isEmpty()
boolean remoteTrigger=!currentBuild.getBuildCauses('hudson.model.Cause$RemoteCause').isEmpty()
upstreamTrigger =!currentBuild.getBuildCauses('org.jenkinsci.plugins.workflow.support.steps.build.BuildUpstreamCause').isEmpty()
agentName= "windows_slave"
executionTag= "executiontag"
executionEnvironment="environment"
buildNumber="buildNo"
xmlName="xml"
uiFailCount=0
browserInfoValue=""
jobName=""
slackThreadResponse=""
slackChannel = suite == "Regression" ? "testautomation" : "testautomation-datamanagement"

pipeline {
    agent none
    tools {
        maven "Maven"
    }
    options {
	    buildDiscarder(logRotator(numToKeepStr: '10'))
	    timestamps()
	    skipDefaultCheckout()
    }
    stages {
     stage('Build Parameter from Upstream Job'){
            agent {label agentName}
            when {
	            expression {upstreamTrigger}
	        }
            steps {
                script {
                    executionTag= params.ExecutionTag
                    agentName= params.AgentLabel
                    executionEnvironment= params.ExecutionEnvironment
                    buildNumber= params.BuildNumber
                    accountName= getAccountName(params.ExecutionEnvironment)
                    slackThreadId =params.SlackThreadId
                    uiFailCount=params.failureCount as Integer
                    namespacePrompt=params.namespacePrompt
                    browserInfoValue= params.browserInfoValue
                    suite=params.suite
                    jobName =params.jobName
                }
           	 }
        } 
        stage('Namespace and Slave prompt') {
       	agent {label "master"}
	        when {
	            expression {!(scheduledTrigger||remoteTrigger||upstreamTrigger)}
	        }
           	steps {
               script {
	               if(params.executionEnv == 'Staging'){
						def inputValue = input(id:'inputValue', message: 'Enter the namespace and the node that you desire to execute on', ok: 'Proceed',
										 parameters: [
	                                        	 string(defaultValue: 'automation',
	                                            description: 'Will run by default on automation, please change if reqd.',
	                                            name: 'namespace'),
	                                         	string(defaultValue: 'windows_slave',
	                                            description: 'Will run by default on windows_slave node, make sure the node is up and connected',
	                                            name: 'node')
	                                        ])
	                    namespacePrompt = inputValue['namespace']
	                    agentName=inputValue['node']
	                    if(params.suite == 'Delete'){
	                        def accInputValue = input(id:'accInputValue', message: 'Enter the account name that you wish to clear data from', ok: 'Proceed',
	                                    parameters: [
	                                    		string(defaultValue: 'enter value',
	                                            description: 'Will delete data for chosen acc and env',
	                                            name: 'accname')
	                                        ])
	                         accountName=accInputValue               
	                                  }
						
	               }else{
	                   def inputValue = input(id:'inputValue', message: 'Enter the node that you desire to execute on', ok: 'Proceed',
	                                    parameters: [
	                                    		string(defaultValue: 'windows_slave',
	                                            description: 'Will run by default on windows_slave, make sure the node is up and connected',
	                                            name: 'node')
	                                        ])
	                        agentName=inputValue
	                        if(params.suite == 'Delete'){
	                        def accInputValue = input(id:'accInputValue', message: 'Enter the account name that you wish to clear data from', ok: 'Proceed',
	                                    parameters: [
	                                    		string(defaultValue: '',
	                                            description: 'Will delete data for chosen acc and env',
	                                            name: 'accname')
	                                        ])
	                         accountName=accInputValue              
	                                  }
	               }
           		}
        	}
        }
        stage('Checkout'){
        	agent {label agentName}
			steps {
				checkout scm
				stash 'projectWS'
			}
		}
        stage('Trigger Type') {
	        parallel {
		        stage('Scheduled/Remote Build'){
			        agent {label agentName}
			        when {
	        			expression {scheduledTrigger || remoteTrigger}
	        		}
		        	stages{
		            	stage('Scheduled Test'){
							steps {
	            				script {
	            					unstash 'projectWS'
					           		if(isUnix()){										
					           			sh 'mvn clean compiler:compile'										
					           			sh "mvn exec:java -Dset.Environment=\"${executionEnv}\" -Dset.Suite=\"${suite}\" -Dset.Module=\"${module}\" -Dset.Namespace=automation -Dset.Account=\"${accountName}\" verify"
					           		}else{
					           			bat 'mvn clean compiler:compile'
					           			bat "mvn exec:java -Dset.Environment=\"${executionEnv}\" -Dset.Suite=\"${suite}\" -Dset.Module=\"${module}\" -Dset.Namespace=automation -Dset.Account=\"${accountName}\" verify"
				           			}
	           					}
							}
							post {
					    		always {
					    			script{
	        	    				    if(currentBuild.currentResult == 'ABORTED')
	        	    				    	slackAbortBuildMessage()
	        	    					}
					    			postExecutionScript(scheduledTrigger,remoteTrigger)
					    		}
					    		success {
		    					    script {
		    					    	if(remoteTrigger){
		    					    		echo "Remote Trigger Build successful"
		    					    	}
    					    		}
		    					}
							}
		            	}
		        	}
		        }
				stage('User Triggered Build'){
				 	agent {label agentName}
				 	when {
        		    	expression {!(scheduledTrigger || remoteTrigger || upstreamTrigger)}
        			}
					stages{
		             	stage('User triggered Test'){
							steps {
	            				script {
	            					unstash 'projectWS'
	            					slackTriggerBuildMessage()
		            				if(isUnix()){
						            	sh 'mvn clean compiler:compile'
					           			sh "mvn exec:java -Dset.Environment=\"${executionEnv}\" -Dset.Suite=\"${suite}\" -Dset.Module=\"${module}\" -Dset.Namespace=\"${namespacePrompt}\" -Dset.Account=\"${accountName}\" verify"
		            				}else{
						            	bat 'mvn clean compiler:compile'
						            	bat "mvn exec:java -Dset.Environment=\"${executionEnv}\" -Dset.Suite=\"${suite}\" -Dset.Module=\"${module}\" -Dset.Namespace=\"${namespacePrompt}\" -Dset.Account=\"${accountName}\" verify"    
		            				}
								}
	        				}
	        				post {
	        	    			always {
	        	    				script{
	        	    				    if(currentBuild.currentResult == 'ABORTED')
	        	    				    	slackAbortBuildMessage()
	        	    					}
	        	    				postExecutionScript(false,false)
	        	    			}
	        				}
		             	}
		            }
				}
				stage('Distributed Tests Execution'){
     	        agent {label agentName}
     	        when {
        	          expression {
        	        	(upstreamTrigger)
        	     	}
        	     }
        	     stages{
         	        stage('Build') {
        	            steps {
            	            script {
            	            	unstash 'projectWS'
            	            	runXml()
            	            }
            	        }
            	        post {
	       					always {
	       						script{
	       						    slackAbortBuildMessage(currentBuild.currentResult == 'ABORTED')
	       						}
	          					step([$class: 'Publisher', reportFilenamePattern: '**/testng-results.xml'])
	          					script{
						        	 def summary = junit testResults: 'target\\surefire-reports\\*.xml'
						        	 def failed = "${summary.failCount}" as Integer
						        	 def passed = "${summary.passCount}" as Double
						        	 def totalCount = "${summary.totalCount}" as Integer
						        	 totalCount = totalCount + uiFailCount
						        	 sendSlackBlockMessage(failed,totalCount)
						     		}
	        				}
      					}
        	         }
        	     }
     	    }
           	}
        }
    }
}

def sendSlackMessage(scheduled,jobDetails,jobStatus,envStatus){
	buildParameters=""
    pipelineDetails="<https://jenkins.stg.webengage.biz/blue/organizations/jenkins/API%20Automation/detail/API%20Automation/${env.BUILD_NUMBER}/pipeline|*View Build Details*>"
	serenityReports="<https://jenkins.stg.webengage.biz/job/API%20Automation/${env.BUILD_NUMBER}/Serenity_20Reports/|*View Execution Reports*>"
	quickGlance="<https://jenkins.stg.webengage.biz/blue/organizations/jenkins/API%20Automation/detail/API%20Automation/${env.BUILD_NUMBER}/tests|Quick glance at all the tests>"
	slackMsg="${jobDetails}\n${jobStatus}\n${envStatus}\n${pipelineDetails}\n${serenityReports}"
	if(!scheduled){
		buildParameters="\n<https://jenkins.stg.webengage.biz/job/API%20Automation/${env.BUILD_NUMBER}/parameters/|*View Build Parameters*>"
	}
	echo "${envStatus}"
	if ( currentBuild.currentResult == "SUCCESS" ) {
		customMsg="*Things are in place!* :+1:"
		slackExecutionMessage="${slackMsg}${buildParameters}\n_${quickGlance}_\n\n${customMsg}";
		colorValue='#00f61d';
	}else{
		customMsg="*Things went haywire! :boom: Please have a look.* "
		slackExecutionMessage="${slackMsg}${buildParameters}\n_${quickGlance}_\n\n${customMsg}";
		colorValue='#df1019';
	}
}

def namespace(namespaceValue){
    if(!namespaceValue.contains("default")){
        return " - "+namespaceValue
    }else{
		return ""
    }
}

def postExecutionScript(scheduled,remote){
	cucumber failedFeaturesNumber: -1, failedScenariosNumber: -1, failedStepsNumber: -1, fileIncludePattern: '**/Cucumber.json', pendingStepsNumber: -1, skippedStepsNumber: -1, sortingMethod: 'ALPHABETICAL', undefinedStepsNumber: -1
	publishHTML([allowMissing: false, alwaysLinkToLastBuild: true, keepAll: true, reportDir: 'target/site/serenity', reportFiles: 'index.html', reportName: 'Serenity Reports', reportTitles: ''])
	script{
		def summary = junit testResults: 'target\\surefire-reports\\*.xml'
		def passed = "${summary.passCount}" as Double
		def failed = "${summary.failCount}" as Integer
		def percentage=((passed/(passed+failed))*100).round(2)
		slackBlockMessageApi(failed,"${summary.totalCount}",percentage,namespace("${namespacePrompt}"),"${summary.skipCount}")
	}

}
def getAccountName(executionEnv){
	switch(executionEnv) {
                        case "Prod US": 
							accountName="UIAutomation"; 
							break
                        case "Prod IN": 
							accountName="UIAutomationIndia"; 
							break
						case "Prod KSA": 
							accountName="UIAutomationKSA"; 
							break
                        case "Staging": 
							accountName="UIAutomationStaging"; 
							break
                    }
	return accountName
}

def runXml() {
xmlName="Analytics_testng.xml";
 if(isUnix()){
	sh 'mvn clean compiler:compile'
	sh 'mvn -Dset.Environment=${executionEnvironment} -Dset.ExecutionTag=${executionTag} -Dset.AccountName=${accountName} -Dset.BuildNumber=${buildNumber} -Dset.Namespace=${namespacePrompt} -DsuiteXmlFile=${xmlName} -P analyticsTest test' 
	}
 else{
 	bat 'mvn clean compiler:compile'
	bat "mvn -Dset.Environment=\"${executionEnvironment}\" -Dset.ExecutionTag=\"${executionTag}\" -Dset.AccountName=\"${accountName}\" -Dset.BuildNumber=\"${buildNumber}\" -Dset.Namespace=\"${namespacePrompt}\" -DsuiteXmlFile=\"${xmlName}\" -P \"analyticsTest\" test"
	}	 
}

def statusIcon(){
	if( currentBuild.currentResult == "SUCCESS" && uiFailCount==0){
		return "https://cdn-icons-png.flaticon.com/512/190/190411.png"
	}else{
		return "https://cdn-icons-png.flaticon.com/512/190/190406.png"
	}
}


  
def sendSlackBlockMessage(failedCount,totalCount){
		iconURL=statusIcon()		
		failResultBlock= [
		[
			"type": "header",
			"text": [
				"type": "plain_text",
				"text": "${jobName} - ${suite} [Build #${buildNumber}]",
				"emoji": true
			]
		],
		[
			"type": "divider"
		],
		[
			"type": "section",
			"fields": [
				[
					"type": "mrkdwn",
					"text": "Environment : \n*${executionEnvironment}* ${namespacePrompt}"
				],
				[
					"type": "mrkdwn",
					"text": "${browserInfoValue}"
				]
			]
		],
		[
			"type": "context",
			"elements": [
				[
					"type": "mrkdwn",
					"text": "Test Summary"
				]
			]
		],
		[
			"type": "section",
			"fields": [
				[
				"type": "mrkdwn",
				"text": "*Total:* \n${totalCount}"
				],
				[
				"type": "mrkdwn",
				"text": "\n"
				],
				[
				"type": "mrkdwn",
				"text": "*UI Failure:* \n${uiFailCount}"
				],
				[
				"type": "mrkdwn",
				"text": "*API Failure:* \n${failedCount}"
				]
			],
			"accessory": [
				"type": "image",
				"image_url": "${iconURL}",
				"alt_text": "status"
			]
		],
		[
			"type": "actions",
			"elements": [
				[	
					"type": "button",
					"text": [
						"type": "plain_text",
						"text": "UI Execution Report",
						"emoji": true
					],
					"value": "click_me_123",
					"url": "https://jenkins.stg.webengage.biz/job/Dashboard%20Automation/${buildNumber}/Serenity_20Reports/",
					"action_id": "button-action"
				],
				[
					"type": "button",
					"text": [
						"type": "plain_text",
						"text": "API Execution Report",
						"emoji": true
					],
					"value": "click_me_123",
					"url": "https://jenkins.stg.webengage.biz/job/API%20Automation/${env.BUILD_NUMBER}/testngreports/",
					"action_id": "actionId-1"
				]
			]
		],
		[
			"type": "divider"
		]
	]
	
	passResultBlock= [
		[
			"type": "header",
			"text": [
				"type": "plain_text",
				"text": "${jobName} - ${suite} [Build #${buildNumber}]",
				"emoji": true
			]
		],
		[
			"type": "divider"
		],
		[
			"type": "section",
			"fields": [
				[
					"type": "mrkdwn",
					"text": "Environment : \n*${executionEnvironment}* ${namespacePrompt}"
				],
				[
					"type": "mrkdwn",
					"text": "${browserInfoValue}"
				]
			]
		],
		[
			"type": "context",
			"elements": [
				[
					"type": "mrkdwn",
					"text": "Test Summary"
				]
			]
		],
		[
			"type": "section",
			"text": [
				"type": "mrkdwn",
				"text": "The execution was successful, total of ${totalCount} tests passed!"
			],
			"accessory": [
				"type": "image",
				"image_url": "${iconURL}",
				"alt_text": "status"
			]
		],
		[
			"type": "actions",
			"elements": [
				[
				
					"type": "button",
					"text": [
						"type": "plain_text",
						"text": "UI Execution Report",
						"emoji": true
					],
					"value": "click_me_123",
					"url": "https://jenkins.stg.webengage.biz/job/Dashboard%20Automation/${buildNumber}/Data_20Analytics_20Regression/",
					"action_id": "button-action"
				],
				[
					"type": "button",
					"text": [
						"type": "plain_text",
						"text": "API Execution Report",
						"emoji": true
					],
					"value": "click_me_123",
					"url": "https://jenkins.stg.webengage.biz/job/API%20Automation/${env.BUILD_NUMBER}/testngreports/",
					"action_id": "actionId-1"
				]
			]
		],
		[
			"type": "divider"
		]
	]
	if(currentBuild.currentResult == "SUCCESS" && uiFailCount==0){
		slackSend(channel: params.SlackThreadId.split(",")[0],timestamp: params.SlackThreadId.split(",")[1],blocks:passResultBlock)                                      
	}
	else
		slackSend(channel: params.SlackThreadId.split(",")[0],timestamp: params.SlackThreadId.split(",")[1],blocks:failResultBlock) 	 
}
def slackBlockMessageApi(failedCount,totalCount,percentage,namespacePrompt,skipCount){
	iconURL=statusIcon()
	uiBlocks = [
	    [      
			"type": "header",
			"text": [
				"type": "plain_text",
				"text": "${env.JOB_NAME} - ${suite} [Build #${env.BUILD_NUMBER}]",
				"emoji": true
			]
		],
		[
			"type": "divider"
		],
		[
			"type": "section",
			"fields": [
				[
					"type": "mrkdwn",
					"text": "Environment : \n*${executionEnv}* ${namespacePrompt}"
				]
			]
		],
		[
			"type": "divider"
		],
		[
			"type": "context",
			"elements": [
				[
					"type": "plain_text",
					"text": "Test Summary",
					"emoji": true
				]
			]
		],
		[
			"type": "section",
			"fields": [
				[
					"type": "mrkdwn",
					"text": "*Total:*\n${totalCount}"
				],
				[
					"type": "mrkdwn",
					"text": "*Failure:*\n${failedCount}"
				],
				[
					"type": "mrkdwn",
					"text": "*Skipped:*\n${skipCount}"
				],
				[
					"type": "mrkdwn",
					"text": "*Percentage:*\n${percentage}%"
				]
			],
			"accessory": [
				"type": "image",
				"image_url": "${iconURL}",
				"alt_text": "status icon"
			]
		],
		[
			"type": "divider"
		],
		[
			"type": "actions",
			"elements": [
				[
					"type": "button",
					"text": [
						"type": "plain_text",
						"text": "Build Details",
						"emoji": true
					],
					"value": "click_me_123",
					"url": "https://jenkins.stg.webengage.biz/blue/organizations/jenkins/API%20Automation/detail/API%20Automation/${env.BUILD_NUMBER}/pipeline",
					"action_id": "actionId-0"
				],
				[
					"type": "button",
					"text": [
						"type": "plain_text",
						"text": "Execution Report",
						"emoji": true
					],
					"value": "click_me_123",
					"url": "https://jenkins.stg.webengage.biz/job/API%20Automation/${env.BUILD_NUMBER}/Serenity_20Reports/",
					"action_id": "actionId-1"
				],
				[
					"type": "button",
					"text": [
						"type": "plain_text",
						"text": "Quick Look",
						"emoji": true
					],
					"value": "click_me_123",
					"url": "https://jenkins.stg.webengage.biz/blue/organizations/jenkins/API%20Automation/detail/API%20Automation/${env.BUILD_NUMBER}/tests",
					"action_id": "actionId-2"
				]
			]
		],
		[
			"type": "divider"
		]
	]
	sendSlackThreadMessage(uiBlocks)
}
def slackTriggerBuildMessage(){
	buildDetails="<https://jenkins.stg.webengage.biz/blue/organizations/jenkins/API%20Automation/detail/API%20Automation/${env.BUILD_NUMBER}/pipeline|*Click here to get more details*>"
	slackMsg="*${env.JOB_NAME} - ${suite}* [<https://jenkins.stg.webengage.biz/job/API%20Automation/${env.BUILD_NUMBER}/|*Build #${env.BUILD_NUMBER}*>] has been triggered on *${executionEnv}*.\nThe reports will get attached to the same thread when ready.\n ${buildDetails}"
	triggerBlock= [
		[
			"type": "section",
			"text": [
				"type": "mrkdwn",
				"text": slackMsg
			]
		]
	]
	def slackResponse=slackSend(channel: slackChannel ,blocks:triggerBlock)
	slackThreadResponse=slackResponse.threadId
}

def slackAbortBuildMessage(booleanValue){
	if(booleanValue){
		buildNumber=upstreamTrigger?buildNumber:env.BUILD_NUMBER
		buildDetails="<https://jenkins.stg.webengage.biz/blue/organizations/jenkins/API%20Automation/detail/API%20Automation/${buildNumber}/pipeline|*Click here to get more details*>"
		slackMsg="<https://jenkins.stg.webengage.biz/job/API%20Automation/${buildNumber}/|*Build #${buildNumber}*> has been aborted.\n${buildDetails}"
		abortBlock= [
			[
				"type": "section",
				"text": [
					"type": "mrkdwn",
					"text": slackMsg
				]
			]
		]
		if(slackThreadId!="id")
			slackSend(channel: slackThreadId.split(",")[0], blocks:abortBlock, timestamp: slackThreadId.split(",")[1])
		else if(slackThreadResponse!="")
			slackSend(channel: slackThreadResponse,replyBroadcast: true,blocks:abortBlock)
		else
			slackSend(channel: slackChannel ,blocks:abortBlock)
		return true
	}else{
		return false
	}
}
def sendSlackThreadMessage(def blocks){
   	slackResponse=""
	if(slackThreadResponse=="")
	    slackResponse=slackSend(channel: slackChannel ,blocks:blocks)
	else
	    slackResponse=slackSend(channel: slackThreadResponse,replyBroadcast: true,blocks:blocks)
}
